precision mediump float;

uniform sampler2D  sTexture;
uniform mediump vec2  TextureSize;
uniform mediump float TimeParameter;

varying mediump vec2   TexCoord;

void main()
{
    gl_FragColor = texture2D(sTexture, TexCoord);
    
    float pi = radians(180.0);
    float deltaT = 1.2 * TimeParameter; // TimeParameter is in [0.0, 1.0]
    vec2 center = TextureSize/2.0;
    vec2 pointVect = TexCoord - center;
    float angle = atan(-pointVect.x, -pointVect.y) + pi;
    float sector = 0.66667 * pi;
    float deltaA = mod(angle, sector) / sector;
    
    gl_FragColor.a = pow(clamp(1.0 - 5.0*(deltaT - deltaA), 0.0, 1.0), 2.0);
}
