precision mediump float;

uniform sampler2D  sTexture;
uniform mediump vec2  TextureSize;
uniform mediump float TimeParameter; 

varying mediump vec2   TexCoord;

void main()
{
    gl_FragColor = texture2D(sTexture, TexCoord);
    
    float diagonal = length(TextureSize)/2.0;
    
    float deltaT = 2.0 * TimeParameter * diagonal; // TimeParameter is in [0.0, 1.0]
    vec2 center = TextureSize/2.0;
    float dist = distance(center, TexCoord);
    
    gl_FragColor.a = pow(clamp(1.0 - (deltaT - dist)/diagonal, 0.0, 1.0), 2.0);
}
