precision mediump float;

uniform sampler2D  sTexture;
uniform mediump float TimeParameter;

varying mediump vec2   TexCoord;

void main()
{
    gl_FragColor = texture2D(sTexture, TexCoord);
    
    float delta = 1.0 - abs(1.0 - 2.0 * clamp(0.0, TimeParameter, 1.0));

    gl_FragColor.xyz = clamp(gl_FragColor.xyz + delta * (1.0 - gl_FragColor.xyz), 0.0, 1.0);
}
